From ed3929dfe7bcf4505c3a639f27be27fd155310c6 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Mar 15 2016 14:30:18 +0000
Subject: [PATCH 326/1001] Allow feed entries to expand/collapse if they are conglomerates.


---

diff --git a/hubs/widgets/feed.py b/hubs/widgets/feed.py
index 19b1c27..492fdbd 100644
--- a/hubs/widgets/feed.py
+++ b/hubs/widgets/feed.py
@@ -43,17 +43,75 @@ template = jinja2.Template("""
       <div class="media-body">
         <h4 class="media-heading">{{match['markup']}}</h4>
         {{match['human_time']}}
+        {% if match['msg_ids'] | length > 1 %}
+            <div class="pull-right">
+                <a id="expand-{{match['dom_id']}}" href="javascript:expand_feed_entries('{{match['dom_id']}}');">
+                    <span class="glyphicon glyphicon-chevron-down"></span>
+                    expand
+                </a>
+                <a id="collapse-{{match['dom_id']}}" href="javascript:collapse_feed_entries('{{match['dom_id']}}');" class="hidden">
+                    <span class="glyphicon glyphicon-chevron-up"></span>
+                    collapse
+                </a>
+            </div>
+            <ul id="content-{{match['dom_id']}}" class="hidden list-unstyled">
+                {% for idx, constituent in match['msg_ids'].items() %}
+                <li>
+                    {{ constituent['markup'] }}
+                    {% if constituent['link'] %}
+                    <a href="{{constituent['link']}}" target="_blank">
+                        <span class="glyphicon glyphicon-new-window"></span>
+                    </a>
+                    {% endif %}
+                </li>
+                {% endfor %}
+            </ul>
+        {% endif %}
       </div>
     </div>
   </div>
 </div>
 {% endfor %}
+<script>
+var expand_feed_entries = function(idx) {
+    $("#expand-" + idx).addClass('hidden');
+    $("#collapse-" + idx).removeClass('hidden');
+    $("#content-" + idx).removeClass('hidden');
+}
+var collapse_feed_entries = function(idx) {
+    $("#expand-" + idx).removeClass('hidden');
+    $("#collapse-" + idx).addClass('hidden');
+    $("#content-" + idx).addClass('hidden');
+}
+</script>
 """)
 
 # No chrome around the feed.
 #from hubs.widgets.chrome import panel
 #chrome = panel()
 
+def apply_markup(match):
+    markup = match['subtitle']
+    for username in match['usernames']:
+        args = (username, '<a href="{url}">@{username}</a>'.format(
+            url=flask.url_for('hub', name=username),
+            username=username,
+        ))
+        markup = markup.replace(*args)
+        # TODO -- have to add these to conglomerate first
+        #match['long_form'] = match['long_form'].replace(*args)
+
+    for package in match['packages']:
+        args = (package, '<a href="{url}">{package}</a>'.format(
+            url='https://apps.fedoraproject.org/packages/' + package,
+            package=package,
+        ))
+        markup = markup.replace(*args)
+        # TODO -- have to add these to conglomerate first
+        #match['long_form'] = match['long_form'].replace(*args)
+
+    return markup
+
 
 @argument(name="username",
           default=None,
@@ -113,25 +171,9 @@ def data(session, widget, username, fmn_context):
 
     # Apply some html markup to the subtitles for extra fanciness.
     for match in matches:
-        match['markup'] = match['subtitle']
-        for username in match['usernames']:
-            args = (username, '<a href="{url}">@{username}</a>'.format(
-                url=flask.url_for('hub', name=username),
-                username=username,
-            ))
-            match['markup'] = match['markup'].replace(*args)
-            # TODO -- have to add these to conglomerate first
-            #match['long_form'] = match['long_form'].replace(*args)
-
-        for package in match['packages']:
-            args = (package, '<a href="{url}">{package}</a>'.format(
-                url='https://apps.fedoraproject.org/packages/' + package,
-                package=package,
-            ))
-            match['markup'] = match['markup'].replace(*args)
-            # TODO -- have to add these to conglomerate first
-            #match['long_form'] = match['long_form'].replace(*args)
-
+        match['markup'] = apply_markup(match)
+        for idx, constituent in match['msg_ids'].items():
+            constituent['markup'] = apply_markup(constituent)
 
     return dict(
         matches=matches,

